package be.jeffcheasey88.peeratcode.parser.java;

import java.util.List;
import java.util.function.BiFunction;
import java.util.function.Function;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class Annotation extends JavaElement{
	
	private static Pattern PATTERN = Pattern.compile("^(\\s*@\\s*([^\\s\\^]*)\\s*(\\^GENERIC_PARENTHESIS\\d+)?)");
	
	private String type;
	private String param;
	
	public Annotation(){}

	@Override
	public int parse(String content, CleanerPool global, CleanerPool local) throws Exception {
		Matcher matcher = PATTERN.matcher(content);
		matcher.lookingAt();
		
		this.type = matcher.group(2);
		this.param = matcher.group(3);
		
		return matcher.group(1).length();
	}
	
	@Override
	public void build(ArrayBuffer<String> buffer, int tab) throws Exception {
		super.build(buffer, tab);
		buffer.append((s) -> s+="@"+type+(param == null ? "":param));
		buffer.add("");
	}

	@Override
	public <E extends JavaElement> E find(Function<JavaElement, Boolean> search, Function<List<JavaElement>, Boolean> deep, List<JavaElement> trace) {
		return null;
	}

	@Override
	public <E extends JavaElement> E find(BiFunction<JavaElement, List<JavaElement>, Boolean> search, List<JavaElement> trace) {
		return null;
	}

	
	
}
