package be.jeffcheasey88.peeratcode.parser.java;

import java.util.List;
import java.util.function.BiFunction;
import java.util.function.Function;

public abstract class JavaElement {

	public abstract int parse(String content, CleanerPool global, CleanerPool local) throws Exception;
	
	public abstract <E extends JavaElement> E find(Function<JavaElement, Boolean> search, Function<List<JavaElement>, Boolean> deep, List<JavaElement> trace);
	public abstract <E extends JavaElement> E find(BiFunction<JavaElement, List<JavaElement>, Boolean> search, List<JavaElement> trace);
	
	public void build(ArrayBuffer<String> buffer, int tab) throws Exception {
		String spacement = "";
		for(int i = 0; i < tab; i++) spacement+="\t";
		final String modifier = spacement;
		buffer.append((s) -> s+=modifier);
	}
}
