package be.jeffcheasey88.peeratcode.parser.java;

import java.lang.reflect.Array;
import java.util.Iterator;

public class ArrayIterator<E> implements Iterator<E>{
	
	private E[] elements;
	private int index;
	
	public ArrayIterator(E[] elements){
		E[] copy = (E[]) Array.newInstance(elements.getClass().getComponentType(), elements.length);
		System.arraycopy(elements, 0, copy, 0, elements.length);
		this.elements = copy;
	}
	
	@Override
	public boolean hasNext(){
		return index < elements.length;
	}

	@Override
	public E next(){
		return elements[index++];
	}
	
	

}
